/*
   joysticks.library, library skeleton
   Generated with LibMaker 0.11.
*/

/****** joysticks.library/background ****************************************
*
* DESCRIPTION
*
* HISTORY
*
*****************************************************************************
*
*/

typedef char* STRPTR;
typedef const char* CONST_STRPTR;
#define STRPTR_TYPEDEF

#define __NOLIBBASE__

#include <proto/exec.h>
#include <proto/locale.h>
#include <proto/muimaster.h>
#include <proto/utility.h>
#include <proto/dos.h>
#include <proto/lowlevel.h>

#include <exec/resident.h>
#include <exec/libraries.h>
#include <exec/system.h>
#include <libraries/query.h>
#include <clib/alib_protos.h>

#include <libraries/acepansion_plugin.h>

#define UNUSED __attribute__((unused))

#include "lib_version.h"
#include "library.h"

#define CATCOMP_BLOCK
#define CATCOMP_NUMBERS
#include "lib_strings.h" /* prototypes and catcomp block */


struct PluginData
{
    // Plugin generic part (do NEVER put anything before this!)
    struct ACEpansionPlugin common;

    // Joysticks specifics
    ULONG portJoystick0;
    ULONG portJoystick1;
};



const char LibName[] = LIBNAME;
extern const char VTag[];

struct Library *SysBase;


struct Library *LibInit(struct Library *unused, APTR seglist, struct Library *sysb);
struct MyLibBase *lib_init(struct MyLibBase *base, APTR seglist, struct Library *SysBase);
APTR lib_expunge(struct MyLibBase *base);
struct Library *LibOpen(void);
ULONG LibClose(void);
APTR LibExpunge(void);
ULONG LibReserved(void);
BOOL InitResources(struct MyLibBase *base);
VOID FreeResources(struct MyLibBase *base);
STRPTR GetString(struct MyLibBase *base, LONG id);
ULONG StrLen(CONST_STRPTR str);

struct ACEpansionPlugin * LibCreatePlugin(struct MyLibBase *base, CONST_STRPTR *toolTypes, struct SignalSemaphore *sema);
VOID LibDeletePlugin(struct MyLibBase *base, struct ACEpansionPlugin *plugin);
BOOL LibActivatePlugin(struct MyLibBase *base, struct ACEpansionPlugin *plugin, BOOL status);
VOID LibReset(struct MyLibBase *base, struct ACEpansionPlugin * plugin);
VOID LibEmulate(struct MyLibBase *base, struct ACEpansionPlugin *plugin, ULONG *signals);
VOID LibWriteIO(struct MyLibBase *base, struct ACEpansionPlugin *plugin, USHORT port, UBYTE value);
VOID LibReadIO(struct MyLibBase *base, struct ACEpansionPlugin *plugin, USHORT port, UBYTE * value);
VOID LibGetAudio(struct MyLibBase *base, struct ACEpansionPlugin *plugin, SHORT * leftSample, SHORT *rightSample);
VOID LibPrinter(struct MyLibBase *base, struct ACEpansionPlugin *plugin, UBYTE data, BOOL strobe, BOOL *busy);
VOID LibCursor(struct MyLibBase *base, struct ACEpansionPlugin *plugin);
VOID LibAcknowledgeInterrupt(struct MyLibBase *base, struct ACEpansionPlugin *plugin, UBYTE *ivr);
VOID LibJoystick(struct MyLibBase *base, struct ACEpansionPlugin *plugin, BOOL com1, BOOL com2, UBYTE *ioData);



BOOL InitResources(struct MyLibBase *base)
{
    BOOL success = FALSE;

    base->LocaleBase = OpenLibrary("locale.library", 0L);
    base->MUIMasterBase = OpenLibrary("muimaster.library", 0L);
    base->DOSBase = OpenLibrary("dos.library", 0L);
    base->UtilityBase = OpenLibrary("utility.library", 0L);
    base->LowLevelBase = OpenLibrary("lowlevel.library", 0L);

    if(base->LocaleBase
    && base->MUIMasterBase
    && base->DOSBase
    && base->UtilityBase
    && base->LowLevelBase)
    {
        struct Library *LocaleBase = base->LocaleBase;

    	if((base->Locale = OpenLocale(NULL)))
        {
    		if((base->Catalog = OpenCatalogA(base->Locale, LIBNAME".catalog", TAG_DONE)))
            {
    			if(base->Catalog->cat_Version  != VERSION
                || base->Catalog->cat_Revision != REVISION)
                {
        			CloseCatalog(base->Catalog);
        			base->Catalog = NULL;
                }
            }
            success = TRUE;
    	}
    }

    return success;
}


VOID FreeResources(struct MyLibBase *base)
{
    if(base->LocaleBase)
    {
        struct Library *LocaleBase = base->LocaleBase;

        if(base->Locale)
        {
            if(base->Catalog)
            {
                CloseCatalog(base->Catalog);
                base->Catalog = NULL;
            }

            CloseLocale(base->Locale);
            base->Locale = NULL;
        }

        CloseLibrary(base->LocaleBase);
        base->LocaleBase = NULL;
    }
    if(base->LowLevelBase)
    {
        CloseLibrary(base->LowLevelBase);
    }
    if(base->UtilityBase)
    {
        CloseLibrary(base->UtilityBase);
    }
    if(base->DOSBase)
    {
        CloseLibrary(base->DOSBase);
    }
    if(base->MUIMasterBase)
    {
        CloseLibrary(base->MUIMasterBase);
    }
}

STRPTR GetString(struct MyLibBase *base, LONG id)
{
    LONG   *l;
    UWORD  *w;
    STRPTR  builtin;

	l = (LONG *)CatCompBlock;

    while(*l != id )
    {
        w = (UWORD *)((ULONG)l + 4);
        l = (LONG *)((ULONG)l + (ULONG)*w + 6);
    }
    builtin = (STRPTR)((ULONG)l + 6);

    if(base->Catalog)
    {
        struct Library *LocaleBase = base->LocaleBase;

        return GetCatalogStr(base->Catalog, id, builtin);
    }
    return builtin;
}

ULONG StrLen(CONST_STRPTR str)
{
    ULONG count = 0;

    while(*str++ != '\0') count++;

    return count;
}


const struct TagItem RTags[] =
{
	{ QUERYINFOATTR_NAME, (IPTR)LibName },
	{ QUERYINFOATTR_IDSTRING, (IPTR)&VTag[1] },
	{ QUERYINFOATTR_COPYRIGHT, (IPTR)" 2016 Philippe Rimauro" },
	{ QUERYINFOATTR_DATE, (IPTR)DATE },
	{ QUERYINFOATTR_VERSION, VERSION },
	{ QUERYINFOATTR_REVISION, REVISION },
	{ QUERYINFOATTR_SUBTYPE, QUERYSUBTYPE_LIBRARY },
	{ TAG_END,  0 }
};

struct Resident ROMTag =
{
	RTC_MATCHWORD,
	&ROMTag,
	&ROMTag + 1,
	RTF_EXTENDED | RTF_PPC,
	VERSION,
	NT_LIBRARY,
	0,
	(char*)LibName,
	VSTRING,
	(APTR)LibInit,
	REVISION,
	(struct TagItem*)RTags
};


APTR JumpTable[] =
{
	(APTR)FUNCARRAY_BEGIN,
	(APTR)FUNCARRAY_32BIT_NATIVE,
	(APTR)LibOpen,
	(APTR)LibClose,
	(APTR)LibExpunge,
	(APTR)LibReserved,
	(APTR)0xFFFFFFFF,
	(APTR)FUNCARRAY_32BIT_SYSTEMV,
	(APTR)LibCreatePlugin,
	(APTR)LibDeletePlugin,
	(APTR)LibActivatePlugin,
	(APTR)LibReset,
	(APTR)LibEmulate,
	(APTR)LibWriteIO,
	(APTR)LibReadIO,
	(APTR)LibGetAudio,
	(APTR)LibPrinter,
	(APTR)LibCursor,
	(APTR)LibAcknowledgeInterrupt,
	(APTR)LibJoystick,
	(APTR)0xFFFFFFFF,
	(APTR)FUNCARRAY_END
};


struct MyLibBase * lib_init(struct MyLibBase *base, APTR seglist, UNUSED struct Library *sysbase)
{
	InitSemaphore(&base->BaseLock);
	base->Seglist = seglist;
	return base;
}

struct TagItem LibTags[] = {
	{ LIBTAG_FUNCTIONINIT, (IPTR)JumpTable },
	{ LIBTAG_LIBRARYINIT,  (IPTR)lib_init },
	{ LIBTAG_MACHINE,      MACHINE_PPC },
	{ LIBTAG_BASESIZE,     sizeof(struct MyLibBase) },
	{ LIBTAG_SEGLIST,      0 },
	{ LIBTAG_TYPE,         NT_LIBRARY },
	{ LIBTAG_NAME,         0 },
	{ LIBTAG_IDSTRING,     0 },
	{ LIBTAG_FLAGS,        LIBF_CHANGED | LIBF_SUMUSED },
	{ LIBTAG_VERSION,      VERSION },
	{ LIBTAG_REVISION,     REVISION },
	{ LIBTAG_PUBLIC,       TRUE },
	{ TAG_END,             0 },
};

struct Library * LibInit(UNUSED struct Library *unused, APTR seglist, struct Library *sysbase)
{
	SysBase = sysbase;

	LibTags[4].ti_Data = (IPTR)seglist;
	LibTags[6].ti_Data = (IPTR)ROMTag.rt_Name;
	LibTags[7].ti_Data = (IPTR)ROMTag.rt_IdString;

	return (NewCreateLibrary(LibTags));
}


struct Library * LibOpen(void)
{
	struct MyLibBase *base = (struct MyLibBase*)REG_A6;
	struct Library *lib = (struct Library*)base;

	ObtainSemaphore(&base->BaseLock);

	if (!base->InitFlag)
	{
		if (InitResources(base)) base->InitFlag = TRUE;
		else
		{
			FreeResources(base);
			lib = NULL;
		}
	}

	if (lib)
	{
		base->LibNode.lib_Flags &= ~LIBF_DELEXP;
		base->LibNode.lib_OpenCnt++;
	}

	ReleaseSemaphore(&base->BaseLock);
	if (!lib) lib_expunge(base);
	return lib;
}


ULONG LibClose(void)
{
	struct MyLibBase *base = (struct MyLibBase*)REG_A6;
	ULONG ret = 0;

	ObtainSemaphore(&base->BaseLock);

	if (--base->LibNode.lib_OpenCnt == 0)
	{
		if (base->LibNode.lib_Flags & LIBF_DELEXP) ret = (ULONG)lib_expunge(base);
	}

	if (ret == 0) ReleaseSemaphore(&base->BaseLock);
	return ret;
}


APTR LibExpunge(void)
{
	struct MyLibBase *base = (struct MyLibBase*)REG_A6;

	return(lib_expunge(base));
}


APTR lib_expunge(struct MyLibBase *base)
{
	APTR seglist = NULL;

	ObtainSemaphore(&base->BaseLock);

	if (base->LibNode.lib_OpenCnt == 0)
	{
		FreeResources(base);
		Forbid();
		Remove((struct Node*)base);
		Permit();
		seglist = base->Seglist;
		FreeMem((UBYTE*)base - base->LibNode.lib_NegSize, base->LibNode.lib_NegSize + base->LibNode.lib_PosSize);
		base = NULL;    /* freed memory, no more valid */
	}
	else base->LibNode.lib_Flags |= LIBF_DELEXP;

	if (base) ReleaseSemaphore(&base->BaseLock);
	return seglist;
}


ULONG LibReserved(void)
{
	return 0;
}



/****** joysticks.library/CreatePlugin **************************************
*
* NAME
*   CreatePlugin -- {short} (V1)
*
* SYNOPSIS
*   struct ACEpansionPlugin * CreatePlugin(CONST_STRPTR *toolTypes, struct SignalSemaphore *sema)
*
* FUNCTION
*   Create the plugin data structure and configure how it will be handled by
*   ACE. This function is usually called at ACE startup.
*
* INPUTS
*   *toolType
*     A pointer to a NULL terminated array of CONST_STRPTR containing the
*     tooltypes provided with the plugin library.
*     The ACTIVE tooltype is handled internally by ACE for all plugins, but
*     you can here handle additional tooltypes to configure your plugin.
*   *sema
*     Pointer to a semaphore to use to protect access to custom data from
*     ACEpansionPlugin when accessed from subtasks or within your PrefsWindow.
*
* RESULT
*     A pointer to an allocated and initialized plugin data structure.
*
* SEE ALSO
*   DeletePlugin
*   ActivatePlugin
*
*****************************************************************************
*
*/

static STRPTR CYA_GroupJoystickPort[] =
{
    (STRPTR)MSG_CYCLE_LOWLEVEL_JOY0,
    (STRPTR)MSG_CYCLE_LOWLEVEL_JOY1,
    (STRPTR)MSG_CYCLE_LOWLEVEL_JOY2,
    (STRPTR)MSG_CYCLE_LOWLEVEL_JOY3,
    NULL
};

static BOOL TranslationDone = FALSE;

static VOID localizeStringArray(struct MyLibBase *base, STRPTR array[])
{
    LONG i = 0;

    while(array[i])
    {
        array[i] = GetString(base,(LONG)array[i]);
        i++;
    }
}

struct ACEpansionPlugin * LibCreatePlugin(struct MyLibBase *base, CONST_STRPTR *toolTypes, UNUSED struct SignalSemaphore *sema)
{
    // We are allocating an extended plugin structure to add our custom stuff
    struct PluginData *plugin = AllocVec(sizeof(struct PluginData), MEMF_PUBLIC|MEMF_CLEAR);

    if(plugin)
    {
        struct Library *MUIMasterBase = base->MUIMasterBase;
        struct Library *UtilityBase = base->UtilityBase;
        struct Library *DOSBase = base->DOSBase;
        Object *CYA_Joy0, *CYA_Joy1;

        if(!TranslationDone)
        {
            localizeStringArray(base,CYA_GroupJoystickPort);
            TranslationDone = TRUE;
        }

        // Initialize plugin specifics
        plugin->portJoystick0 = 1; // Joy1 of the Amiga is Joy0 of the CPC!
        plugin->portJoystick1 = 0;

        // Get tooltypes to configure ourself
        while(*toolTypes)
        {
            CONST_STRPTR ptr = *toolTypes;
            CONST_STRPTR name = ptr;
            ULONG len = 0;

            if(*ptr != '(')
            {
                while(*ptr != '=' && *ptr != '\0')
                {
                    ptr++;
                    len++;
                }

                if(*ptr == '=')
                {
                    if(!Strnicmp(name,"JOYSTICK0",len))
                    {
                        CONST_STRPTR value = ptr+1;

                        if(*value != '\0')
                        {
                            StrToLong(value, (LONG *)&plugin->portJoystick0);
                        }
                    }
                    else if(!Strnicmp(name,"JOYSTICK1",len))
                    {
                        CONST_STRPTR value = ptr+1;

                        if(*value != '\0')
                        {
                            StrToLong(value, (LONG *)&plugin->portJoystick1);
                        }
                    }
                }
            }
            toolTypes++;
        }

        // Initialize plugin generic part
        plugin->common.ap_APIVersion     = 2;
        plugin->common.ap_Flags          = ACE_FLAGSF_ACTIVE_JOYSTICK; // We need the joysticks API (but we are not exclusive)
        plugin->common.ap_Title          = GetString(base,MSG_TITLE);
        plugin->common.ap_HelpFileName   = LIBNAME".guide";
        plugin->common.ap_ToggleMenuName = GetString(base,MSG_MENU_TOGGLE);
        plugin->common.ap_PrefsMenuName  = GetString(base,MSG_MENU_PREFS);
        plugin->common.ap_PrefsWindow    = MUI_NewObject(MUIC_Group,
            MUIA_Group_Columns, 2,
            MUIA_Disabled, TRUE,
            MUIA_ShortHelp, (IPTR)GetString(base,MSG_CYCLE_BUBBLE_HELP),
            Child, (IPTR)Label2(GetString(base,MSG_LABEL_JOY0)),
        	Child, (IPTR)(CYA_Joy0 = MUI_NewObject(MUIC_Cycle,
        		MUIA_Cycle_Entries, (IPTR)&CYA_GroupJoystickPort,
                MUIA_Cycle_Active, plugin->portJoystick0,
        		TAG_END)),
            Child, (IPTR)Label2((IPTR)GetString(base,MSG_LABEL_JOY1)),
        	Child, (IPTR)(CYA_Joy1 = MUI_NewObject(MUIC_Cycle,
        		MUIA_Cycle_Entries, (IPTR)&CYA_GroupJoystickPort,
                MUIA_Cycle_Active, plugin->portJoystick1,
        		TAG_END)),
            TAG_END);

        DoMethod(CYA_Joy0, MUIM_Notify, MUIA_Cycle_Active, MUIV_EveryTime,
                 (IPTR)CYA_Joy0, 3, MUIM_WriteLong, MUIV_TriggerValue, (IPTR)&plugin->portJoystick0);
        DoMethod(CYA_Joy1, MUIM_Notify, MUIA_Cycle_Active, MUIV_EveryTime,
                 (IPTR)CYA_Joy1, 3, MUIM_WriteLong, MUIV_TriggerValue, (IPTR)&plugin->portJoystick1);
    }

    return (struct ACEpansionPlugin *)plugin;
}



/****** joysticks.library/DeletePlugin **************************************
*
* NAME
*   DeletePlugin -- {short} (V1)
*
* SYNOPSIS
*   VOID DeletePlugin(struct ACEpansionPlugin *plugin)
*
* FUNCTION
*   Delete a plugin data structure. This function is usually called when ACE
*   is exiting.
*
* INPUTS
*   *plugin
*     Pointer to the plugin data structure to delete.
*
* RESULT
*
* SEE ALSO
*   CreatePlugin
*   ActivatePlugin
*
*****************************************************************************
*
*/

VOID LibDeletePlugin(struct MyLibBase *base, struct ACEpansionPlugin *plugin)
{
    struct PluginData *myPlugin = (struct PluginData *)plugin;
    struct Library *MUIMasterBase = base->MUIMasterBase;

    MUI_DisposeObject(myPlugin->common.ap_PrefsWindow);
    FreeVec(myPlugin);
}



/****** joysticks.library/ActivatePlugin ************************************
*
* NAME
*   ActivatePlugin -- {short} (V1)
*
* SYNOPSIS
*   BOOL ActivatePlugin(struct ACEpansionPlugin *plugin, BOOL status)
*
* FUNCTION
*   This function is called everytime ACE wants to activate or disactivate your plugin.
*   While you are disactivated, no other function (except Delete) will the called by ACE.
*   Please note that a plugin is always disactivated by ACE prior to DeletePlugin().
*
* INPUTS
*   activate
*     New activation status requested by ACE.
*
* RESULT
*   Actual activation status (you may fail at activation for some reason, but you
*   should never fail at disactivation request).
*
* SEE ALSO
*   CreatePlugin
*   DeletePlugin
*
*****************************************************************************
*
*/

BOOL LibActivatePlugin(UNUSED struct MyLibBase *base, struct ACEpansionPlugin *plugin, BOOL activate)
{
    struct PluginData *myPlugin = (struct PluginData *)plugin;

    DoMethod(myPlugin->common.ap_PrefsWindow, MUIM_Set, MUIA_Disabled, !activate);

    return activate;
}



/****** joysticks.library/Reset *********************************************
*
* NAME
*   Reset -- {short} (V1)
*
* SYNOPSIS
*   VOID Reset(struct ACEpansionPlugin *plugin)
*
* FUNCTION
*   Function that is called everytime ACE is issuing a bus reset.
*
* INPUTS
*   *plugin
*     Pointer to the plugin data structure to use.
*
* RESULT
*
* SEE ALSO
*   Emulate
*
*****************************************************************************
*
*/

VOID LibReset(UNUSED struct MyLibBase *base, UNUSED struct ACEpansionPlugin *plugin)
{
}



/****** joysticks.library/Emulate *******************************************
*
* NAME
*   Emulate -- {short} (V1)
*
* SYNOPSIS
*   VOID Emulate(struct ACEpansionPlugin *plugin, ULONG *signals)
*
* FUNCTION
*   Function that is called at each microsecond of the emulation step inside ACE.
*   Note: Implement this function only if is it really required for your plugin because it
*   is obviously CPU intensive.
*
* INPUTS
*   *plugin
*     Pointer to the plugin data structure to use.
*   *signals
*     Pointer to the I/O signals from the expansion port you can use or alter depending
*     on what you are emulating.
*     The signals bits can be decoded using the following flags:
*       ACE_SIGNALF_INT
*
* RESULT
*
* SEE ALSO
*   Reset
*
*****************************************************************************
*
*/

VOID LibEmulate(UNUSED struct MyLibBase *base, UNUSED struct ACEpansionPlugin *plugin, UNUSED ULONG *signals)
{
}



/****** joysticks.library/WriteIO *******************************************
*
* NAME
*   WriteIO -- {short} (V1)
*
* SYNOPSIS
*   VOID WriteIO(struct ACEpansionPlugin *plugin, USHORT port, UBYTE value)
*
* FUNCTION
*   Function that is called everytime Z80 is performing a I/O port write operation.
*   Note: Implement this function only if is it really required for your plugin because it
*   is obviously CPU intensive.
*
* INPUTS
*   port
*     Z80 port on with the I/O write operation was issued.
*   value
*     Value that was issued on the port.
*
* RESULT
*
* SEE ALSO
*   ReadIO
*
*****************************************************************************
*
*/

VOID LibWriteIO(UNUSED struct MyLibBase *base, UNUSED struct ACEpansionPlugin *plugin, UNUSED USHORT port, UNUSED UBYTE value)
{
}



/****** joysticks.library/ReadIO ********************************************
*
* NAME
*   ReadIO -- {short} (V1)
*
* SYNOPSIS
*   VOID ReadIO(struct ACEpansionPlugin *plugin, USHORT port, UBYTE *value)
*
* FUNCTION
*   Function that is called everytime Z80 is performing a I/O port read operation.
*   Note: Implement this function only if is it really required for your plugin because it
*   is obviously CPU intensive.
*
* INPUTS
*   port
*     Z80 port on with the I/O read operation was issued.
*   *value
*     Value to be returned.
*
* RESULT
*
* SEE ALSO
*   WriteIO
*
*****************************************************************************
*
*/

VOID LibReadIO(UNUSED struct MyLibBase *base, UNUSED struct ACEpansionPlugin *plugin, UNUSED USHORT port, UNUSED UBYTE *value)
{
}



/****** joysticks.library/GetAudioSample ************************************
*
* NAME
*   GetAudioSample -- {short} (V1)
*
* SYNOPSIS
*   VOID GetAudio(struct ACEpansionPlugin *plugin, SHORT *leftSample, SHORT *rightSample)
*
* FUNCTION
*   Function to be used when your plugin needs to mix an audio output with the one
*   from ACE.
*   It is called at each PSG emulation step, which means at 125KHz.
*
* INPUTS
*   *leftSample
*     Pointer to store the left audio sample to be mixed with ACE audio.
*   *rightSample
*     Pointer to store the right audio sample to be mixed with ACE audio.
*
* RESULT
*
* SEE ALSO
*
*****************************************************************************
*
*/

VOID LibGetAudio(UNUSED struct MyLibBase *base, UNUSED struct ACEpansionPlugin *plugin, UNUSED SHORT *leftSample, UNUSED SHORT *rightSample)
{
}



/****** joysticks.library/Printer *******************************************
*
* NAME
*   Printer -- {short} (V1)
*
* SYNOPSIS
*   VOID WritePrinter(struct ACEpansionPlugin *plugin, UBYTE data, BOOL strobe, BOOL *busy)
*
* FUNCTION
*   Function that is called everytime the CPC is accessing the printer port.
*
* INPUTS
*   data
*     8 bits written value (note that CPC is limited to 7 bits values, only Amstrad Plus
*     can actually provide the 8th bit).
*   strobe
*     Status of the /STROBE signal from the printer port.
*   *busy
*     Busy signal value that can be altered.
*
* RESULT
*
* SEE ALSO
*
*****************************************************************************
*
*/

VOID LibPrinter(UNUSED struct MyLibBase *base, UNUSED struct ACEpansionPlugin *plugin, UNUSED UBYTE data, UNUSED BOOL strobe, UNUSED BOOL *busy)
{
}



/****** joysticks.library/Cursor ********************************************
*
* NAME
*   Cursor -- {short} (V1)
*
* SYNOPSIS
*   VOID Cursor(struct ACEpansionPlugin *plugin)
*
* FUNCTION
*
* INPUTS
*
* RESULT
*
* SEE ALSO
*
*****************************************************************************
*
*/

VOID LibCursor(UNUSED struct MyLibBase *base, UNUSED struct ACEpansionPlugin *plugin)
{
}



/****** joysticks.library/AcknowledgeInterrupt ******************************
*
* NAME
*   AcknowledgeInterrupt -- {short} (V1)
*
* SYNOPSIS
*   VOID AcknowledgeInterrupt(struct ACEpansionPlugin *plugin, UBYTE *ivr)
*
* FUNCTION
*
* INPUTS
*
* RESULT
*
* SEE ALSO
*
*****************************************************************************
*
*/

VOID LibAcknowledgeInterrupt(UNUSED struct MyLibBase *base, UNUSED struct ACEpansionPlugin *plugin, UNUSED UBYTE *ivr)
{
}



/****** joysticks.library/Joystick ******************************************
*
* NAME
*   Joystick -- {short} (V1)
*
* SYNOPSIS
*   VOID Joystick(struct ACEpansionPlugin *plugin, BOOL com1, BOOL com2, UBYTE *ioData)
*
* FUNCTION
*   Function which is called everytime the CPC is accessing the joystick port.
*   Please note that the joystick port in R/W but you cannot know if the CPC
*   is actually reading or writing to it.
*
* INPUTS
*   com1
*     If com1 is active then the CPC is requesting access to joystick 0.
*   com2
*     If com2 is active then the CPC is requesting access to joystick 1.
*   *ioData
*     If the CPC is reading the joystick port (regular case) ioData will be set
*     to 0xff and you are supposed to set to 0 the bits corresponding to the
*     requested joystick (you should use the ACE_IODATAF_JOYSTICK_XXX defines).
*     Please note the additional ACE_IODATAF_JOYSTICK_PAUSE which is not
*     existing on CPC but that you could use to map the play/pause button of
*     a joystick used in ACE on the 'P' key of the keyboard (or the GX4000
*     pause button).
*     If the CPC is writing the joystick port the ioData will contain the
*     written value to the port and modifying it will have not effect (on a
*     real CPC it could simply destroy the PSG chipset!).
*
* RESULT
*
* SEE ALSO
*
*****************************************************************************
*
*/

#define SET_JOY(amigaflags, dataflags, amigamask, datamask) \
    if((amigaflags) & (amigamask)) (dataflags) &= ~(datamask)

VOID LibJoystick(struct MyLibBase *base, struct ACEpansionPlugin *plugin, BOOL com1, BOOL com2, UBYTE *ioData)
{
    struct PluginData *myPlugin = (struct PluginData *)plugin;
    struct Library *LowLevelBase = base->LowLevelBase;
    ULONG joy;

    if(com1 || com2)
    {
        joy = ReadJoyPort(com1?myPlugin->portJoystick0:myPlugin->portJoystick1);

        if(joy & (JP_TYPE_GAMECTLR|JP_TYPE_JOYSTK))
        {
            SET_JOY(joy, *ioData, JPF_JOY_UP       , ACE_IODATAF_JOYSTICK_UP   );
            SET_JOY(joy, *ioData, JPF_JOY_DOWN     , ACE_IODATAF_JOYSTICK_DOWN );
            SET_JOY(joy, *ioData, JPF_JOY_LEFT     , ACE_IODATAF_JOYSTICK_LEFT );
            SET_JOY(joy, *ioData, JPF_JOY_RIGHT    , ACE_IODATAF_JOYSTICK_RIGHT);
            SET_JOY(joy, *ioData, JPF_BUTTON_BLUE  , ACE_IODATAF_JOYSTICK_FIRE1);
            SET_JOY(joy, *ioData, JPF_BUTTON_RED   , ACE_IODATAF_JOYSTICK_FIRE2);
            SET_JOY(joy, *ioData, JPF_BUTTON_YELLOW, ACE_IODATAF_JOYSTICK_FIRE3);
            SET_JOY(joy, *ioData, JPF_BUTTON_PLAY  , ACE_IODATAF_JOYSTICK_PAUSE);
        }
    }
}
